<?php
//grab our display options
$display_options = get_option('wp_coupons_display_options');

//secondary form tab specific actions
if(!empty($_GET['tab'])) {
	if($_GET['tab'] == 'display') {
		//restore default display options
		if(!empty($_POST['restore'])) {
			$defaults = wp_coupons_default_display_options();
			if(!empty($defaults)) {
				update_option("wp_coupons_display_options", $defaults);
			}
		}
	} 
	elseif($_GET['tab'] == 'styling') {
		//restore default styling options
		if(!empty($_POST['restore'])) {
			$defaults = wp_coupons_default_styling_options();
			if(!empty($defaults)) {
				update_option("wp_coupons_styling_options", $defaults);
			}
		}
	} 
	elseif($_GET['tab'] == 'extra') {
		//restore default styling options
		if(!empty($_POST['restore'])) {
			$defaults = wp_coupons_default_extra_options();
			if(!empty($defaults)) {
				update_option("wp_coupons_extra_options", $defaults);
			}
		}
	} 
}
?>
<style>
.wp-coupons-subnav a {
	display: inline-block;
	font-size: 16px; 
	margin: 10px auto;
	padding: 10px;
	text-decoration: none;
	box-shadow: none;
	-webkit-box-shadow: none;
	-moz-box-shadow: none;
	border-bottom: 2px solid transparent;
}
.wp-coupons-subnav a.active {
	color: #333333;
	border-bottom: 2px solid #333333;
}
.wp-coupons-section-heading {
	padding: 10px 0px 10px 0px;
	border-bottom: 1px solid #ddd;
}
.wp-coupons-section-heading h2 {
	font-size: 28px;
	line-height: normal;
	margin: 0px 0px 5px 0px;
}
.wp-coupons-section-heading p {
	margin: 0px;
}

.section-content.active {
	display: block;
}
.section-content.hide {
	display: none;
}
</style>
<div class="wrap wp-coupons-admin">
	<h2><?php _e('WP Coupons Settings', 'wp_coupons'); ?></h2>

		<!-- Notice to view the plugin on Woorkup -->
		<div class="notice notice-info">
        	<p>
        		<?php
        		$woorkup_link = "<a href='https://woorkup.com/deals/?utm_source=wp-admin&utm_medium=plugins&utm_campaign=wpcoupons' title='Woorkup' target='_blank'>woorkup.com</a>";
        		printf(__('Check out WP Coupons in action on %s.', 'wp_coupons'), $woorkup_link); 
        		?>
        	</p>
    	</div>
		<?php 
		//if no tab is set  yet, default to the first one, display options
		if(empty($_GET['tab'])) {
			$_GET['tab'] = 'display';
		} 
		?>
		
		<!-- Tab Navigation -->
		<h2 class="nav-tab-wrapper">
			<a href="?page=wp_coupons&tab=display" class="nav-tab <?php echo $_GET['tab'] == 'display' ? 'nav-tab-active' : ''; ?>"><?php _e('Display Options', 'wp_coupons'); ?></a>
			<a href="?page=wp_coupons&tab=styling" class="nav-tab <?php echo $_GET['tab'] == 'styling' ? 'nav-tab-active' : ''; ?>"><?php _e('Style Options', 'wp_coupons'); ?></a>
			<a href="?page=wp_coupons&tab=extra" class="nav-tab <?php echo $_GET['tab'] == 'extra' ? 'nav-tab-active' : ''; ?>"><?php _e('Extras', 'wp_coupons'); ?></a>
			<a href="?page=wp_coupons&tab=license" class="nav-tab <?php echo $_GET['tab'] == 'license' ? 'nav-tab-active' : ''; ?>"><?php _e('License', 'wp_coupons'); ?></a>
			<a href="?page=wp_coupons&tab=support" class="nav-tab <?php echo $_GET['tab'] == 'support' ? 'nav-tab-active' : ''; ?>"><?php _e('Support', 'wp_coupons'); ?></a>
			<?php if(!empty($display_options['wp_coupons_enable_archive']) && $display_options['wp_coupons_enable_archive'] == "1") { ?>
				<?php if(!empty($display_options['wp_coupons_archive_slug'])){$wp_coupons_slug = $display_options['wp_coupons_archive_slug'];}else{$wp_coupons_slug = 'coupons';} ?>
				<?php $wp_coupons_slug = site_url() . "/" . $wp_coupons_slug . "/"; ?>
				<a href="<?php echo $wp_coupons_slug; ?>" class="nav-tab" target="_blank" style="color: #0073aa;" title="<?php _e('Coupon Archive', 'wp_coupons'); ?>"><?php echo $wp_coupons_slug; ?></a>
			<?php } ?>
		</h2>
		
		<!-- Main Form -->
		<form method="post" action="options.php" id="wp-coupons-options-form">
			<?php
			if($_GET['tab'] == 'display') {
				settings_fields( 'wp_coupons_display_options' );
				do_settings_sections('wp_coupons_display_options', 'wp_coupons_display_settings');
				submit_button();
			}
			elseif($_GET['tab'] == 'styling') {
				echo "<input type='hidden' name='section' id='subnav-section' />";
				echo "<div class='wp-coupons-subnav'>";
					echo "<a href='#styling-colors' id='colors-section' rel='colors' class='active'>" . __('Colors', 'wp_coupons') . "</a>";
					echo "<a href='#styling-fonts' id='fonts-section' rel='fonts'>" . __('Fonts', 'wp_coupons') . "</a>";
				echo "</div>";
				settings_fields('wp_coupons_styling_options');
				echo "<section id='styling-colors' class='section-content active'>";
					wp_coupons_section('wp_coupons_styling_options', 'wp_coupons_colors');
				echo "</section>";
				echo "<section id='styling-fonts' class='section-content hide'>";
					wp_coupons_section('wp_coupons_styling_options', 'wp_coupons_fonts');
				echo "</section>";
				submit_button();
			} 
			elseif($_GET['tab'] == 'extra') {
				settings_fields( 'wp_coupons_extra_options' );
				do_settings_sections( 'wp_coupons_extra_options' );
				submit_button();
			}
			elseif($_GET['tab'] == 'support') {
				echo "<h2>" . __('Support', 'wp_coupons') . "</h2>";
				$wp_coupons_link = "<a href='https://wpcoupons.io/' title='WP Coupons' target='_blank'>wpcoupons.io</a>";
				echo "<p>" . sprintf('For plugin support and documentation, please visit %s.', $wp_coupons_link) . "</p>"; 
				echo "<p>" . __("*Tip*: Your main coupon archive will look best if your coupon featured images are all the same size. You'll want to use the image dimensions that match your theme. (Our sample image dimensions are 794x398)", 'wp_coupons') . "</p>";
				echo "<h2>" . __('Shortcodes', 'wp_coupons') . "</h2>";
				echo "<p><h3>" . __('Single Coupon Shortcode') . "</h3>" . __('Example', 'wp_coupons') . ": <strong>[coupon id=\"1\"]</strong></p>";
				echo "<ul style='list-style: square; margin-left: 40px;'>";
					echo "<li><strong>id</strong> - " . __('The id of the coupon post that you want to display. Required', 'wp_coupons') . "</li>";
				echo "</ul>";
				echo "<p><h3>" . __('Coupon Archive Shortcode', 'wp_coupons') . "</h3>" . __('Example', 'wp_coupons') . ": <strong>[wp_coupons limit=\"9\" tag=\"summer 2016\" nav=\"false\"]</strong></p>";
				echo "<ul style='list-style: square; margin-left: 40px;'>";
					echo "<li><strong>limit</strong> - " . __('The maximum number of posts to display per page. Not Required, Default: 9', 'wp_coupons') . "</li>";
					echo "<li><strong>tag</strong> - " . __('The coupon tag you wish to display. This will cause the shortcode to only pull in coupons that have the given tag. Not Required', 'wp_coupons') . "</li>";
					echo "<li><strong>nav</strong> - " . __("If set to 'false', this will hide the primary coupon type navigation. Not Required, Default: true", 'wp_coupons') . "</li>";
				echo "</ul>";
			}
			elseif($_GET['tab'] == 'license') {
				$license_info = wp_coupons_edd_check_license();
				$license = get_option('wp_coupons_edd_license_key');
				$status = get_option('wp_coupons_edd_license_status');
				settings_fields('wp_coupons_edd_license');

				?>

				<table class="form-table">
					<tbody>
						<tr>
							<th><?php _e('License Key', 'wp_coupons'); ?></th>
							<td>
								<input id="wp_coupons_edd_license_key" name="wp_coupons_edd_license_key" type="password" class="regular-text" value="<?php esc_attr_e($license); ?>" />
								<label class="description" for="wp_coupons_edd_license_key"><?php _e('Enter your license key', 'wp_coupons'); ?></label>
							</td>
						</tr>
						<?php if( false !== $license ) { ?>
							<tr>
								<th><?php _e('Activate License', 'wp_coupons'); ?></th>
								<td>
									<?php if( $status !== false && $status == 'valid' ) { ?>
										<?php wp_nonce_field( 'wp_coupons_edd_nonce', 'wp_coupons_edd_nonce' ); ?>
										<input type="submit" class="button-secondary" name="wp_coupons_edd_license_deactivate" value="<?php _e('Deactivate License', 'wp_coupons'); ?>"/>
										<span style="color:green; display: block; margin-top: 10px;"><?php _e('License is activated.', 'wp_coupons'); ?></span>
									<?php } else {
										wp_nonce_field( 'wp_coupons_edd_nonce', 'wp_coupons_edd_nonce' ); ?>
										<input type="submit" class="button-secondary" name="wp_coupons_edd_license_activate" value="<?php _e('Activate License', 'wp_coupons'); ?>"/>
										<span style="color:red; display: block; margin-top: 10px;"><?php _e('License is not activated.', 'wp_coupons'); ?></span>
									<?php } ?>
								</td>
							</tr>
							<?php if(!empty($license_info)) { ?>

								<!-- Customer Email Address -->
								<?php if(!empty($license_info->customer_email)) { ?>
									<tr>
										<th><?php _e('Customer Email', 'wp_coupons'); ?></th>
										<td><?php echo $license_info->customer_email; ?></td>
									</tr>
								<?php } ?>

								<!-- License Status (Active/Expired) -->
								<?php if(!empty($license_info->license)) { ?>
									<tr>
										<th><?php _e('License Status', 'wp_coupons'); ?></th>
										<td <?php if($license_info->license == "expired"){echo "style='color: red;'";} ?>>
											<?php echo $license_info->license; ?>
											<?php if(!empty($license) && $license_info->license == "expired") { ?>
												<br /><a href="https://wpcoupons.io/checkout/?edd_license_key=<?php echo $license; ?>&download_id=2303" class="button-primary" style="margin-top: 10px;" target="_blank"><?php _e('Renew Your License for Updates + Support!', 'wp_coupons'); ?></a>
											<?php } ?>
										</td>
									</tr>
								<?php } ?>

								<!-- Licenses Used -->
								<?php if(!empty($license_info->site_count) && !empty($license_info->license_limit)) { ?>
									<tr>
										<th><?php _e('Licenses Used', 'wp_coupons'); ?></th>
										<td><?php echo $license_info->site_count . "/" . $license_info->license_limit; ?></td>
									</tr>
								<?php } ?>

							<?php } ?>

						<?php } ?>
					</tbody>
				</table>
				<?php 
				if($license === false) {
					submit_button(__('Save License', 'wp_coupons'));
				}
			}
			?>
		</form>

		<!-- secondary form used to reset default settings per tab -->
		<?php if($_GET['tab'] != 'support' && $_GET['tab'] != 'license') { ?>

			<form method="post" action="" id="wp-coupons-restore" onsubmit="return confirm('<?php _e('Restore default settings?', 'wp_coupons'); ?>');">
				<input type='submit' id='restore' name='restore' class='button button-secondary' value='<?php _e('Restore Defaults', 'wp_coupons'); ?>'>
			</form>

			<div id="wp-coupons-legend">
				<div id="wp-coupons-tooltip-legend">
					<span>?</span><?php _e('Click on tooltip icons to view full documentation.', 'wp_coupons'); ?>
				</div>
			</div>

		<?php } ?>
</div>