<?php
//Single Coupon Shortcode to Print Out Basic Coupon Meta and Image
function wp_coupons_coupon_shortcode($params)
{
	//load plugin options
	$wp_coupons_display = get_option('wp_coupons_display_options');
	$wp_coupons_extra = get_option('wp_coupons_extra_options');

	//start output
	$var = "";

	//add user style overrides
	$var.= wp_coupons_css_overrides();

	//shortcode container
	$var.= "<div class='wp-coupons'>";
		$var.= "<div class='wp-coupons-shortcode'>";

			//prepare query args
			if(!empty($params['id'])) {
				$args = array('post_type'=>'coupon', 'p' => $params['id']);
			}
			else {
				$excluded_posts = get_posts(array(
					'post_type'      => 'coupon',
					'posts_per_page' => -1,
				    'meta_key'       => 'wp_coupons_exclude_rotation',
				    'meta_value'     => '1'
				));
				$excluded_post_ids = array();
				if(!empty($excluded_posts)) {
					foreach($excluded_posts as $key => $value)
					{
						array_push($excluded_post_ids, $value->ID);
					}
				}
				$args = array('post_type'=>'coupon', 'orderby'=>'rand', 'posts_per_page'=>'1', 'post__not_in' => $excluded_post_ids); //no forced coupon is set
				remove_all_filters('posts_orderby');
			}

			//print coupon panels
			$coupon = new WP_Query($args);
			if($coupon->have_posts()) {
				while($coupon->have_posts()) {
					$coupon->the_post();

					if(!is_array($params)) { $params = array(); }
					$params['button'] = true;
					$var.= wp_coupons_coupon_panel(get_the_ID(), $params);
				}
			}
			wp_reset_query();

			//clipboard.js inline script
			if(!empty($wp_coupons_extra['wp_coupons_clipboard_js']) && $wp_coupons_extra['wp_coupons_clipboard_js'] == "1") {
				if(has_action('wp_footer', 'wp_coupons_output_clipboard_js') == false) {
					add_action('wp_footer', 'wp_coupons_output_clipboard_js');
				}
			}

			//click to reveal popup
			if(!empty($wp_coupons_display['wp_coupons_click_to_reveal'])) {
				if(has_action('wp_footer', 'wp_coupons_output_ctr_popup') == false) {
					add_action('wp_footer', 'wp_coupons_output_ctr_popup');
				}
			}

		$var.= "</div>";
	$var.= "</div>";
 	return $var;
}
add_shortcode('coupon', 'wp_coupons_coupon_shortcode');

//Main Coupon Archive Shortcode / Can be used as an alternative to the custom archive template
function wp_coupons_archive_shortcode($params)
{
	$display_options = get_option('wp_coupons_display_options');
	$wp_coupons_extra = get_option('wp_coupons_extra_options');
	$coupons_page_link = get_the_permalink();

	if(!empty($params['type']) && strpos($params['type'], ',') !== false) {
		$params['type'] = array_map('trim', explode(',', $params['type']));
	}

	if(!empty($params['tag']) && strpos($params['tag'], ',') !== false) {
		$params['tag'] = array_map('trim', explode(',', $params['tag']));
	}

/*	if(!empty($_GET['tag'])) {
		if(empty($params)) {
			$params = array();
		}
		$params['tag'] = $_GET['tag'];
	}
*/
	//start output
	$var = "";
	
	//add user style overrides
	$var.= wp_coupons_css_overrides();

	//outer container
	$var.= "<div class='" . (!empty($display_options['wp_coupons_nav_style']) ? 'wp-coupons-nav-style-' . $display_options['wp_coupons_nav_style'] : '') . "' style='overflow: hidden;'>";

		//navigation
		if(empty($params['nav']) || $params['nav'] != 'false') {

			if(!empty($display_options['wp_coupons_nav_title'])) {
				$nav_title = $display_options['wp_coupons_nav_title'];
			}
			else {
				$nav_title = __('All Coupons', 'wp_coupons');
			}

			//main navigation
			$var.= "<div class='wp-coupons-nav'>";

				//dropdown style
				if(!empty($display_options['wp_coupons_nav_style']) && $display_options['wp_coupons_nav_style'] == 'dropdown') {

					$var.= "<select class='wp-coupons-nav-dropdown'>";

						if(empty($params['type']) || is_array($params['type'])) {
							$var.= "<option value='" . get_the_permalink() . "'" . (empty($_GET['type']) ? ' selected=selected' : '') . ">" . $nav_title . "</option>";
						}
						else {
							$_GET['type'] = $params['type'];
						}
						$types = get_terms('type');
						if(!empty($types)) {
							$object_id = '';
							foreach($types as $type) {
								if(empty($params['type']) || (!empty($params['type']) && ($params['type'] == $type->slug || (is_array($params['type']) && in_array($type->slug, $params['type']))))) {
									if(!empty($params['tag'])) {
										$args = array(
								                'post_type' => 'coupon',
								                'posts_per_page' => 1,
								                'tax_query' => array(
								                	'relation' => 'AND',
								                    array(
								                        'taxonomy' => 'type',
								                        'field' => 'slug',
								                        'terms' => $type->slug
								                    ),
								                    array(
								                    	'taxonomy' => 'coupon-tag',
								                    	'field' => 'slug',
								                    	'terms' => $params['tag']
								                    )
								                )
								            );
								        $type_post_check = new WP_Query($args);
								        if($type_post_check->have_posts()) {
								        	$var.= "<option value='?type=" . $type->slug . "' title='" . $type->name . "'" . (!empty($_GET['type']) && $_GET['type'] == $type->slug ? ' selected=selected' : '') . ">" . $type->name . "</option>";
								        }
								        else {
								        	continue;
								        }
									}
									else {
										$var.= "<option value='?type=" . $type->slug . "' title='" . $type->name . "'" . (!empty($_GET['type']) && $_GET['type'] == $type->slug ? ' selected=selected' : '') . ">" . $type->name . "</option>";
									}
								}
								if(!empty($_GET['type']) && $_GET['type'] == $type->slug) {
									$object_id = $type->term_id;
								}
							}
						}

					$var.= "</select>";

				}
				//regular style
				else {
					if(empty($params['type']) || is_array($params['type'])) {
						$var.= "<a href='" . get_the_permalink() . "' title='" . $nav_title . "' class='"; if(empty($_GET['type'])) { $var.= 'wp-coupons-nav-selected'; } $var.= "'>" . $nav_title . "</a>";
					}
					else {
						$_GET['type'] = $params['type'];
					}
					$types = get_terms('type');
					if(!empty($types)) {
						$object_id = '';
						foreach($types as $type) {
							if(empty($params['type']) || (!empty($params['type']) && ($params['type'] == $type->slug || (is_array($params['type']) && in_array($type->slug, $params['type']))))) {
								if(!empty($params['tag'])) {
									$args = array(
							                'post_type' => 'coupon',
							                'posts_per_page' => 1,
							                'tax_query' => array(
							                	'relation' => 'AND',
							                    array(
							                        'taxonomy' => 'type',
							                        'field' => 'slug',
							                        'terms' => $type->slug
							                    ),
							                    array(
							                    	'taxonomy' => 'coupon-tag',
							                    	'field' => 'slug',
							                    	'terms' => $params['tag']
							                    )
							                )
							            );
							        $type_post_check = new WP_Query($args);
							        if($type_post_check->have_posts()) {
							        	$var.= "<a href='?type=" . $type->slug . "' title='" . $type->name . "' class='"; if(!empty($_GET['type']) && $_GET['type'] == $type->slug) { $var.= 'wp-coupons-nav-selected'; } $var.= "'>" . $type->name . "</a>";
							        }
							        else {
							        	continue;
							        }
								}
								else {
									$var.= "<a href='?type=" . $type->slug . "' title='" . $type->name . "' class='"; if(!empty($_GET['type']) && $_GET['type'] == $type->slug) { $var.= 'wp-coupons-nav-selected'; } $var.= "'>" . $type->name . "</a>";
								}
							}
							if(!empty($_GET['type']) && $_GET['type'] == $type->slug) {
								$object_id = $type->term_id;
							}
						}
					}
				}
			$var.= "</div>";

			//Check for coupon type navigation variable
			if(!empty($_GET['type'])) {
				$tax_query = array(array('taxonomy' => 'type', 'field' => 'slug', 'terms' => $_GET['type']));

				//subnav
				if(empty($params['tag']) || is_array($params['tag'])) {
					if(!empty($display_options['wp_coupons_enable_subnav']) && $display_options['wp_coupons_enable_subnav'] == "1") {

						$args = array(
							'posts_per_page' => -1, 
							'post_type' => 'coupon',
							'tax_query' => array(
								array(
									'taxonomy' => 'type',
									'field' => 'term_id',
									'terms' => $object_id
								)
							),
							'meta_query' => array(
								array(
									'key'     => 'wp_coupons_exclude_archive',
									'value'   => '1',
									'compare' => 'NOT EXISTS'
								)
							)
						);
						$coupon_posts = get_posts($args);
						$coupon_post_ids = wp_list_pluck($coupon_posts, 'ID');
						$coupon_post_terms = wp_get_object_terms($coupon_post_ids, 'coupon-tag');

						if(!empty($params['tag']) && is_array($params['tag'])) {
							$coupon_post_terms = array_filter($coupon_post_terms, function($obj) use ($params) {
								if(in_array($obj->slug, $params['tag'])) {
									return true;
								}
								return false;
							});
						}

						if(!empty($coupon_post_terms)) {
							$var.= "<div class='wp-coupons-subnav'>";
								$term_link = get_term_link($object_id);
								$full_link = site_url($_SERVER['REQUEST_URI']);
								$split_uri = explode($term_link, $full_link);
								$split_uri = explode('/', $split_uri[1]);

								ksort($coupon_post_terms);
								foreach($coupon_post_terms as $key => $object) {
									$var.= "<a href='?type=" . $_GET['type'] . "&tag=" . $object->slug . "' class='" . ((!empty($_GET['tag']) && $_GET['tag'] == $object->slug) ? "active" : "") . "'>" . $object->name . "</a>";
								}
							$var.= "</div>";
						}
	 				}
	 			}
			}
			else {
				$tax_query = '';
			}
		}

		if(!empty($params['type'])) {
			if(!empty($tax_query)) {
				$tax_query['relation'] = 'AND';
				$tax_query[] = array('taxonomy' => 'type', 'field' => 'slug', 'terms' => $params['type']);
			}
			else {
				$tax_query = array(array('taxonomy' => 'type', 'field' => 'slug', 'terms' => $params['type']));
			}
		}

		if(!empty($params['tag']) || !empty($_GET['tag'])) {
			if(!empty($_GET['tag'])) {
				if(empty($params)) {
					$params = array();
				}
				$params['tag'] = $_GET['tag'];
			}
			if(!empty($tax_query)) {
				$tax_query['relation'] = 'AND';
				$tax_query[] = array('taxonomy' => 'coupon-tag', 'field' => 'slug', 'terms' => $params['tag']);
			}
			else {
				$tax_query = array(array('taxonomy' => 'coupon-tag', 'field' => 'slug', 'terms' => $params['tag']));
			}
		}

		if(!empty($params['limit'])) {
			$limit = $params['limit'];
		}
		else {
			$limit = 9;
		}

		if(!empty($_GET['list'])) {
			$list = $_GET['list'];
		}
		else {
			$list = "";
		}

		$excluded_posts = get_posts(array(
			'post_type'      => 'coupon',
			'posts_per_page' => -1,
		    'meta_key'       => 'wp_coupons_exclude_archive',
		    'meta_value'     => '1'
		));
		$excluded_post_ids = array();
		if(!empty($excluded_posts)) {
			foreach($excluded_posts as $key => $value)
			{
				array_push($excluded_post_ids, $value->ID);
			}
		}

		//archive sort order
		$sort_order = 'date';
		$order = 'DESC';
        if(!empty($display_options['wp_coupons_archive_sort_order'])) {
        	$sort_order = $display_options['wp_coupons_archive_sort_order'];

        	//set ascending order if sorting by title
        	if($display_options['wp_coupons_archive_sort_order'] == 'title') {
        		$order = 'ASC';
        	}
        }
				
		$loop = new WP_Query(array('post_type' => 'coupon', 'posts_per_page' => $limit, 'tax_query' => $tax_query, 'paged' => $list, 'post__not_in' => $excluded_post_ids, 'orderby' => $sort_order, 'order' => $order));

		$j = 0; 

		$var.= "<div class='wp-coupons-coupons-container'>";

			$var.= "<div style='overflow: hidden;'>";

				if(!empty($params['layout'])) {
					$archive_layout = $params['layout'];
				}
				elseif(!empty($display_options['wp_coupons_archive_layout'])) {
					$archive_layout = $display_options['wp_coupons_archive_layout'];
				}
				else {
					$archive_layout = "";
				}

				$row_labels = array("2" => "two", "3" => "three", "4" => "four", "5" => "five");

				//coupon feed
				if($loop->have_posts()) :
					while($loop->have_posts()) : $loop->the_post(); 
						$j++;

						if(empty($archive_layout) || is_numeric($archive_layout)) {

							$columns = !empty($archive_layout) ? $archive_layout : "3";

							if(($j == 1) || (($j-1) % $columns == 0)) {
								$var.= "<div class='coupon-row " . $row_labels[$columns] . "-columns'>";
							}

							//coupon panels
							$var.= "<div class='wp-coupons-coupon";
							$column_labels = array("2" => "second", "3" => "third", "4" => "fourth", "5" => "fifth");
							for($x = $columns; $x > 1; $x--) {
								if($j % $x == 0) {
									$var.= " " . $column_labels[$x];
								}
							}
							$var.= "'>";
					            $var.= wp_coupons_coupon_panel(get_the_ID());
							$var.= "</div>";

							if(($j % $columns == 0) || ($j == $loop->post_count)) {
								$var.= "</div>";
							}

						}
						elseif($archive_layout == 'list' || $archive_layout == 'list-compact' || $archive_layout == 'list-minimal') {
							$var.= "<div class='coupon-row'>";
								$var.= "<div class='wp-coupons-coupon " . str_replace('-', ' ', $archive_layout) . "'>";
									$var.= wp_coupons_coupon_panel(get_the_ID());
								$var.= "</div>";
							$var.= "</div>";
						}

					endwhile; 

				endif;

			$var.= "</div>";

			//pagination
			if(!empty($_GET['list'])) {
				$page_num = $_GET['list'];
			}
			else {
				$page_num = 1;
			}

			$var.= "<div class='wp-coupons-navigation'>";
				$var.= paginate_links(array(
					'base' => $coupons_page_link . '%_%',
					'format' => '?list=%#%',
					'current' => $page_num,
					'total' => $loop->max_num_pages,
					'prev_text' => "« " . __('Prev', 'wp_coupons'),
					'next_text' => __('Next', 'wp_coupons') . " »",
				));
			$var.= "</div>";

		$var.= "</div>";
	$var.= "</div>";

	wp_reset_query();

	//dropdown nav js
	if(!empty($display_options['wp_coupons_nav_style']) && $display_options['wp_coupons_nav_style'] == "dropdown") {
		if(has_action('wp_footer', 'wp_coupons_output_nav_dropdown_js') == false) {
			add_action('wp_footer', 'wp_coupons_output_nav_dropdown_js');
		}
	}

	//clipboard.js inline script
	if(!empty($wp_coupons_extra['wp_coupons_clipboard_js']) && $wp_coupons_extra['wp_coupons_clipboard_js'] == "1") {
		if(has_action('wp_footer', 'wp_coupons_output_clipboard_js') == false) {
			add_action('wp_footer', 'wp_coupons_output_clipboard_js');
		}
	}

	//click to reveal popup
	if(!empty($display_options['wp_coupons_click_to_reveal'])) {
		if(has_action('wp_footer', 'wp_coupons_output_ctr_popup') == false) {
			add_action('wp_footer', 'wp_coupons_output_ctr_popup');
		}
	}

 	return $var;
}
add_shortcode('wp_coupons', 'wp_coupons_archive_shortcode');