<?php 
get_header();
do_action('wp_coupons_action_before_main_content');
$wp_coupons_display = get_option('wp_coupons_display_options');
$wp_coupons_extra = get_option('wp_coupons_extra_options');
echo wp_coupons_css_overrides();

//before archive content
if(!empty($wp_coupons_extra['wp_coupons_before_archive_content'])) {
	echo "<div class='wp-coupons-before-archive-content'>";
		echo do_shortcode($wp_coupons_extra['wp_coupons_before_archive_content']);
	echo "</div>";
}

//main coupons wrapper
echo "<div id='wp-coupons' class='" . (!empty($wp_coupons_display['wp_coupons_nav_style']) ? 'wp-coupons-nav-style-' . $wp_coupons_display['wp_coupons_nav_style'] : '') . "'>";

	//main navigation
	echo "<div class='wp-coupons-nav'>";

		//display settings
		$archive_slug = !empty($wp_coupons_display['wp_coupons_archive_slug']) ? $wp_coupons_display['wp_coupons_archive_slug'] : 'coupons';
		$nav_title = !empty($wp_coupons_display['wp_coupons_nav_title']) ? $wp_coupons_display['wp_coupons_nav_title'] : __('All Coupons', 'wp_coupons');

		//dropdown style
		if(!empty($wp_coupons_display['wp_coupons_nav_style']) && $wp_coupons_display['wp_coupons_nav_style'] == 'dropdown') {

			echo "<select class='wp-coupons-nav-dropdown'>";

				//print title option
				echo "<option value='" . site_url() . "/" . $archive_slug . "/'" . (!strpos($_SERVER['REQUEST_URI'], "all-" . $archive_slug) ? " selected=selected" : "") . "'>" . $nav_title . "</option>";

				//print type options
				$types = get_terms('type');
				if(!empty($types)) {
					foreach($types as $type) {
						echo "<option value='" . get_term_link($type) . "'" . (strpos($_SERVER['REQUEST_URI'], $type->slug) ? " selected=selected" : "") . "'>" . $type->name . "</option>";
					}
				}

			echo "</select>";

		}
		//regular style
		else {

			//print nav title
			echo "<a href='" . site_url() . "/" . $archive_slug . "/' title='" . $nav_title . "' class='" . (!strpos($_SERVER['REQUEST_URI'], "all-" . $archive_slug) ? "wp-coupons-nav-selected" : "") . "'>" . $nav_title . "</a>";

			//print type navigation
			$types = get_terms('type');
			if(!empty($types)) {
				foreach($types as $type) {
					echo "<a href='" . get_term_link($type) . "' title='" . $type->name . "' class='" . (strpos($_SERVER['REQUEST_URI'], $type->slug) ? "wp-coupons-nav-selected" : "") . "'>" . $type->name . "</a>";
				}
			}
		}

	echo "</div>";

	//subnavigation
	if(!is_post_type_archive('coupon') && !empty($wp_coupons_display['wp_coupons_enable_subnav']) && $wp_coupons_display['wp_coupons_enable_subnav'] == "1") {

		$object_id = get_queried_object_id();
		$args = array(
			'posts_per_page' => -1, 
			'post_type' => 'coupon',
			'tax_query' => array(
				array(
					'taxonomy' => 'type',
					'field' => 'term_id',
					'terms' => $object_id
				)
			)
		);
		$coupon_posts = get_posts($args);
		$coupon_post_ids = wp_list_pluck($coupon_posts, 'ID');
		$coupon_post_terms = wp_get_object_terms($coupon_post_ids, 'coupon-tag');

		if(!empty($coupon_post_terms)) {
			echo "<div class='wp-coupons-subnav'>";
				$term_link = get_term_link($object_id);
				$full_link = site_url($_SERVER['REQUEST_URI']);
				$split_uri = explode($term_link, $full_link);
				$split_uri = explode('/', $split_uri[1]);

				ksort($coupon_post_terms);
				foreach($coupon_post_terms as $key => $object) {
					echo "<a href='" . $term_link . $object->slug . "' class='" . ($object->slug == $split_uri[0] ? "active" : "") . "'>" . $object->name . "</a>";
				}
			echo "</div>";
		}
	}

	//coupons container
	echo "<div class='wp-coupons-coupons-container'>";

		echo "<div style='overflow: hidden;'>";

			$row_labels = array("2" => "two", "3" => "three", "4" => "four", "5" => "five");

			$j = 0; if (have_posts()) : while (have_posts()) : the_post(); $j++;

				$wp_coupons_discount_url = get_post_meta($post->ID, 'wp_coupons_discount_url', true);
				$wp_coupons_direct_link = get_post_meta($post->ID, 'wp_coupons_direct_link', true);
				$wp_coupons_ctr_link = "";

				if(empty($wp_coupons_display['wp_coupons_archive_layout']) || is_numeric($wp_coupons_display['wp_coupons_archive_layout'])) {

					$columns = !empty($wp_coupons_display['wp_coupons_archive_layout']) ? $wp_coupons_display['wp_coupons_archive_layout'] : "3";

					if(($j == 1) || (($j-1) % $columns == 0)) {
						echo "<div class='coupon-row " . $row_labels[$columns] . "-columns'>";
					}

					echo "<div class='wp-coupons-coupon";

					$column_labels = array("2" => "second", "3" => "third", "4" => "fourth", "5" => "fifth");
					for($x = $columns; $x > 1; $x--) {
						if($j % $x == 0) {
							echo " " . $column_labels[$x];
						}
					}

					echo "'>";

						echo wp_coupons_coupon_panel($post->ID);

					echo "</div>";
					if(($j % $columns == 0) || ($j == $wp_query->post_count)) {
						echo "</div>";
					}

				}
				elseif($wp_coupons_display['wp_coupons_archive_layout'] == 'list' || $wp_coupons_display['wp_coupons_archive_layout'] == 'list-compact' || $wp_coupons_display['wp_coupons_archive_layout'] == 'list-minimal') {
					echo "<div class='coupon-row'>";
						echo "<div class='wp-coupons-coupon " . str_replace('-', ' ', $wp_coupons_display['wp_coupons_archive_layout']) . "'>";
							echo wp_coupons_coupon_panel($post->ID);
						echo "</div>";
					echo "</div>";
				}

			endwhile; endif;

		echo "</div>";

		wp_coupons_pagination();

	echo "</div>";
echo "</div>";

if(!empty($wp_coupons_extra['wp_coupons_after_archive_content'])) {
	echo "<div class='wp-coupons-after-archive-content'>";
		echo do_shortcode($wp_coupons_extra['wp_coupons_after_archive_content']);
	echo "</div>";
}

if(!empty($wp_coupons_display['wp_coupons_nav_style']) && $wp_coupons_display['wp_coupons_nav_style'] == "dropdown") {
	if(has_action('wp_footer', 'wp_coupons_output_nav_dropdown_js') == false) {
		add_action('wp_footer', 'wp_coupons_output_nav_dropdown_js');
	}
}

if(!empty($wp_coupons_extra['wp_coupons_clipboard_js']) && $wp_coupons_extra['wp_coupons_clipboard_js'] == "1") {
	if(has_action('wp_footer', 'wp_coupons_output_clipboard_js') == false) {
		add_action('wp_footer', 'wp_coupons_output_clipboard_js');
	}
}

if(!empty($wp_coupons_display['wp_coupons_click_to_reveal'])) {
	if(has_action('wp_footer', 'wp_coupons_output_ctr_popup') == false) {
		add_action('wp_footer', 'wp_coupons_output_ctr_popup');
	}
}

do_action('wp_coupons_action_after_main_content');
get_footer();